function [tu,tv,tp,tw,fu1,fu2,fu3,fv1,fv2,fv3, ...
          fu1_x,fu2_x,fu3_x,fv1_y,fv2_y,fv3_y] =   accfuncsnl(xx,yy,nu);

% tu = time * (  (cos(pi*x/2))^2*cos(pi*y/2)*sin(pi*y/2)  )
% tv = time * (  -cos(pi*x/2)*sin(pi*x/2)*(cos(pi*y/2))^2 
% tp = time * ( cos(pi*x/2)*sin(pi*y/2) )

pxd2 = pi*xx/2; pyd2=pi*yy/2; 
cpxd2 = cos(pxd2); cpyd2 = cos(pyd2); spxd2 = sin(pxd2); spyd2 = sin(pyd2);

% u

tu = cpxd2.^2.*cpyd2.*spyd2;
tux = -pi*cpxd2.*cpyd2.*spyd2.*spxd2;
tuy = (pi/2)*(cpxd2.^2.*cpyd2.^2-cpxd2.^2.*spyd2.^2);
tuxx = (pi^2/2)*(spxd2.^2.*cpyd2.*spyd2-cpxd2.^2.*cpyd2.*spyd2);
tuyx = (pi^2/2)*(cpxd2.*spyd2.^2.*spxd2-spxd2.*cpyd2.^2.*cpxd2);
tuxy = tuyx;  tuyy = -(pi^2)*(cpxd2.^2.*cpyd2.*spyd2);
tuyyx = (pi^3)*(spxd2.*cpyd2.*spyd2.*cpxd2);  laptu = tuxx+tuyy;

% v

tv =  -cpxd2.*spxd2.*cpyd2.^2;
tvx = (pi/2)*(spxd2.^2.*cpyd2.^2-cpxd2.^2.*cpyd2.^2);
tvy = pi*cpxd2.*cpyd2.*spyd2.*spxd2; tvxx = (pi^2)*spxd2.*cpyd2.^2.*cpxd2;
tvxy = (pi^2/2)*(cpxd2.^2.*cpyd2.*spyd2-spxd2.^2.*cpyd2.*spyd2);
tvxyx = -(pi^3)*spxd2.*cpyd2.*spyd2.*cpxd2;
tvyy = (pi^2/2)*(spxd2.*cpyd2.^2.*cpxd2-cpxd2.*spyd2.^2.*spxd2);
laptv = tvxx+tvyy;

% p

tp =  cpxd2.*spyd2; 
tpx = -(pi/2)*spxd2.*spyd2; tpxx = -(pi^2/4)*cpxd2.*spyd2;  
tpy =  (pi/2)*cpxd2.*cpyd2; tpyy = -(pi^2/4)*cpxd2.*spyd2;
laptp = tpxx+tpyy;

% w - vorticity

tw=tvx-tuy; twx=tvxx-tuyx; twy=tvxy-tuyy; twyx=tvxyx-tuyyx; twxy=twyx;

% set force terms

fu1 = tpx + nu*twy; fu2 = tu; fu3 = tu.*tux + tv.*tuy;
fv1 = tpy + nu*(-twx); fv2 = tv; fv3 = tu.*tvx + tv.*tvy;
fu1_x = tpxx + nu*twyx;  fu2_x = tux;
fu3_x = tux.^2 + tu.*tuxx + tvx.*tuy + tv.*tuxy;
fv1_y = tpyy + nu*(-twxy);  fv2_y = tvy;
fv3_y = tu.*tvxy + tuy.*tvx + tv.*tvyy + tvy.^2;

