  function [D1,Dx,Dy,D2,D2T,xx,yy,dt,nts,TFINAL,  ...
            c0_m,c0_p,cN_m,cN_p,b0,bN,e,          ... 
            Q,QT,invQ,invQT,Qevals_mat,          ...
            R,RT,invR,invRT,Revals_mat] = setup(N,nu,cfl,tfinal)

  NP1=N+1; NM1=N-1;
  [D1,x]=cheb(N); y=x; Dx = D1; Dy = D1'; D2 = D1*D1; D2T = D2';
  [xx,yy]=meshgrid(x,y); xx=xx'; yy=yy'; 

% compute stable dt and number of time steps

  dx=x(1)-x(2);  dt=cfl*dx;  nts=floor(tfinal/dt);  TFINAL=nts*dt;

% Setup collocation matrices

  [Q,evals]=eig(D2(2:N,2:N)); evals=diag(evals); 
  QT=Q'; invQ =inv(Q); invQT = invQ';
  Qevals_mat = 1-(nu*dt/2)*(repmat(evals,1,NM1)+repmat(evals',NM1,1));

  c0_m = -D1(1,NP1); c0_p = D1(NP1,NP1); cN_p = -D1(NP1,1); cN_m = D1(1,1);
  b0 = -c0_p*D1(1,2:N)-c0_m*D1(NP1,2:N); bN = -cN_m*D1(NP1,2:N)-cN_p*D1(1,2:N);
  e=c0_p*cN_m - c0_m*cN_p;

  [R,evals] = eig(D2(2:N,2:N)+(1/e)*(D2(2:N,1)*b0+D2(2:N,NP1)*bN));   
  evals = diag(evals); [evals,ind] = sort(evals); evals = flipud(evals); 
  evals(1)=0;  R=R(:,flipud(ind)'); RT = R'; invR =inv(R); invRT = invR';
  Revals_mat = repmat(evals,1,NM1)+repmat(evals',NM1,1); Revals_mat(1,1)=1;
